Make syntax highlighting pluggable

2009-03-16 17:38 - Jean-Baptiste Barth

Status: Closed Start date: 2009-03-16

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version: 1.0.0 (RC)   

Resolution: Fixed   

Description

As discussed in #1651, actual CodeRay support in Redmine is limited, and it could be interesting to make syntax highlighting

pluggable. Here is a proposal which keeps actual CodeRay behaviour by default, and allow plugins to implement syntax highlighting.

See syntax_highlighting.diff

The second patch prevents Redcloth from escaping some chars when they're in a code block which will be treated by syntax

highlighter. There's also a minor change to desactivate a broken (useless?) facility. It doesn't matter for coderay, but other

highlighters like Ultraviolet cannot parse code with ampersands everywhere... Note this patch is necessary if you want the plugin

below to work well in wikis sections (no impact on attached files). Also note the same kind of trick can easily solve #1416. See

redcloth.diff

As an example, I leave a basic plugin to support Ultraviolet syntax highlighting, with active4d theme. It's quite simple, you just have to

make your own module under Redmine::SyntaxHighlighting and define some methods. See ultraviolet_highlighter.zip

Any comment about all that is welcome !

Related issues:

Related to Redmine - Patch #1651: Hack to make redmine use pygmentize instead... Closed 2008-07-15

Related to Redmine - Feature #3032: Use google Prettify for syntax highlighti... Closed 2009-03-23

Related to Redmine - Feature #1313: Optionally use ultraviolet for syntax hig... Closed 2008-05-27

Associated revisions

Revision 3582 - 2010-03-14 10:05 - Jean-Philippe Lang

Do not html escape code that is going to be highlighted (#2985, #3359).

Revision 3584 - 2010-03-14 13:57 - Jean-Philippe Lang

Extract CodeRay calls to Redmine::SyntaxHighlighting (#2985).

History

#1 - 2010-03-14 15:38 - Jean-Philippe Lang

- File ultraviolet_highlighter.zip added

- Category set to Text formatting

- Status changed from New to Closed

- Target version set to 1.0.0 (RC)

- Resolution set to Fixed

Code highlighting methods where extracted to a module in r3584. It doesn't support online configuration in application settings but it can be replaced

with a plugin.

Attached a simple plugin that make use of Ultraviolet. BTW, it seems way slower than Coderay, at least for ruby highlighting.

#2 - 2010-03-15 00:02 - Kornelius Kalnbach

I read on the German Ruby forum that UV was about 20 times slower that CodeRay. But they really use the TextMate bundles, which are very

complex. It's still fast enough for a lot of projects (Pastie, most notably), and they support a lot more languages.

Pygments would be faster, but if you have to call it via a shell command each time you want to highlight something, it may be even slower than

Ultraviolet.
https://www.redmine.org/issues/1651
http://ultraviolet.rubyforge.org/
https://www.redmine.org/issues/1416
http://ultraviolet.rubyforge.org/
https://www.redmine.org/projects/redmine/repository/svn/revisions/3584
syntax_highlighting.diff 9.11 KB 2009-03-16 Jean-Baptiste Barth

redcloth.diff 3.54 KB 2009-03-16 Jean-Baptiste Barth

ultraviolet_highlighter.zip 21.8 KB 2009-03-16 Jean-Baptiste Barth

ultraviolet_highlighter.zip 3.04 KB 2010-03-14 Jean-Philippe Lang

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

